# 遺伝アルゴリズムの初期個体集合にFTを入れ、エリート選択を実装し、適応度の計算で並列化を適用している
# データ取り 世代と平均頂点間距離の関係
#世代間のループすべてを並列化 交差と突然変異

# .csv 世代変化
# .txt ベスト個体

import numpy as np
import networkx as nx
import matplotlib.pyplot as plt
import itertools
import warnings
warnings.filterwarnings("ignore", category=UserWarning)
import copy
import random
from scipy.sparse.csgraph import shortest_path, floyd_warshall, dijkstra, bellman_ford, johnson
from scipy.sparse import csr_matrix
from operator import attrgetter
import sys
import math
import time
import joblib
from networkx.algorithms.shortest_paths.weighted import all_pairs_dijkstra_path_length
from joblib import Parallel, delayed

time1 = time.time()

n = 100 #頂点数

k = 5 #次数

n_ind    = 30 #個体数

CXPB     = 0.5 #交叉確率

MUTPB    = 0.3  #突然変異確率

NGEN     = 100 #世代数

E = int(n * k / 2) #辺の数

FTG = nx.Graph()
FTG.add_nodes_from([i for i in range(0, n)])
#seed = 82

def main():

    t_wa = 0

    # --- Step1 : Create initial generation.
    pop = func_chromosome(n_ind)

    func_ft()
    ft_kotai = list(FTG.edges)
    ft_kotai = Individual(ft_kotai)
    pop.append(ft_kotai)


    set_fitness(value_func, pop)

    best_ind = min(pop, key = attrgetter("fitness"))
    #print("best_ind={}".format(best_ind))

    # --- Generation loop.

    print("Generation loop start.")

    print("Generation: 0. Best fitness: " + str(best_ind.fitness))

    with open("n100k5.csv", "a") as fp:
        print("{},{}".format(0,best_ind.fitness), file=fp)

    count = 0 

    for g in range(NGEN):
        # --- Step2 : Selection.

        # エリート選択
        elite1 = elite_selection(pop)

        # トーナメント選択
        # エリート選択2回分を除いた状態でトーナメント選択
        t_select = n_ind - 2
        offspring = selTournament(pop, t_select, tournsize = 4)

        # --- Step3 : Crossover.
        start = time.time()

        num_kotai = len(offspring)

        crossover = []

        vertex = list(range(0, num_kotai, 2))

        crossover = joblib.Parallel(n_jobs = -1, verbose = 0)([joblib.delayed(para_cross)(offspring, i) for i in vertex])

        offspring = crossover[:]

        offspring = [item for l in offspring for item in l]

        fin = time.time()

        jikan = fin - start
        #print("jikan:{}".format(jikan))

        t_wa += jikan
        count += 1

    # --- Step4 : Mutation.
        num_kotai2 = len(offspring)
        vertex2 = list(range(0, num_kotai2, 1))

        mutant = []

        mutant = joblib.Parallel(n_jobs = -1, verbose = 0)([joblib.delayed(para_mutation)(offspring, i) for i in vertex2])

        offspring = mutant[:]

        offspring = [item for l in offspring for item in l]


    # --- Update next population.
        offspring = elite1 + offspring

        pop = offspring[:]
        

        set_fitness(value_func, pop)
        best_ind = min(pop, key=attrgetter("fitness"))

        print("Generation: " + str(g+1) + ". Best fitness: " + str(best_ind.fitness))

        with open("n100k5.csv", "a") as fp:
            print("{},{}".format(g+1,best_ind.fitness), file=fp)


    print("Generation loop ended. The best individual: ")

    best = list(best_ind)
    best = irekae(best, E)
    with open("best_n100.txt", "w") as fp:
        print(best, file=fp)

    time2 = time.time()
    difftime = time2 - time1
    print("time:{}".format(difftime))

    
    with open("n100k5.csv", "a") as fp:
        print("{}".format(difftime), file=fp)
        print("average_time:{}".format(t_wa/NGEN), file=fp)
        #print("count:{}".format(count))
        print("n = {}, k = {}, n_ind = {}".format(n, k, n_ind), file=fp)
        print("CXPB = {}, MUTPB = {}".format(CXPB, MUTPB), file=fp)
        
        print("fullparallel.py",file=fp)


def para_cross(offspring, i):

    re_crossover = []

    if random.random() < CXPB: #random.random 0.0以上1.0未満

        child1 = offspring[i]
        child2 = offspring[i+1]
                
        child1 = list(child1)
        child2 = list(child2)

        a_lis = irekae(child1, E)
        b_lis = irekae(child2, E)

        cutpoint_a, cutpoint_b = cutplace(n, a_lis, b_lis, E)

        kotai_a, kotai_b = cross(a_lis, b_lis, cutpoint_a, cutpoint_b)

        nd_a = degree_check(kotai_a, n)
        nd_b = degree_check(kotai_b, n)


        re_kotai_a = edge_delete(nd_a, k, kotai_a, n)
        re_kotai_b = edge_delete(nd_b, k, kotai_b, n)


            # 次数k以下の個体ok
            # Havel-Hakimiへ
        regular_kotai_a, double_a = havel(re_kotai_a, n)
        regular_kotai_b, double_b = havel(re_kotai_b, n)


            # 多重辺の可能性あり
            # 2awitch

        ari1 = len(double_a) #多重辺の判定
        if ari1 != 0:
            k_kotai_a = switch(double_a, regular_kotai_a, n)

            kotai_a = Individual(k_kotai_a)
        else:
            kotai_a = Individual(regular_kotai_a)

                #regular_kotai_b, double_b = havel(re_kotai_b)

        ari2 = len(double_b) #多重辺の判定
        if ari2 != 0:
            k_kotai_b = switch(double_b, regular_kotai_b, n)

            kotai_b = Individual(k_kotai_b)
        else:
            kotai_b = Individual(regular_kotai_b)


        kotai_a.fitness = None
        kotai_b.fitness = None

        #return kotai_a, kotai_b
        re_crossover.append(kotai_a)
        re_crossover.append(kotai_b)
            
    else:
        #return child1, child2
        child1 = offspring[i]
        child2 = offspring[i+1]
        re_crossover.append(child1)
        re_crossover.append(child2)

    return re_crossover


def para_mutation(offspring, i):
    re_mutation = []

    if random.random() < MUTPB:
    # print("mutation:{}".format(mut))

        mut = offspring[i]
        change_mut = list(mut)
                
        after_mut = irekae(change_mut, E)
        mut2 = mutation(after_mut)
        mut3 = Individual(mut2)
        mut3.fitness = None
        re_mutation.append(mut3)

    else:
        mut = offspring[i]
        re_mutation.append(mut)

    return re_mutation

def func_chromosome(n_ind):
    """初期個体生成

    Return
    -----------
    pop:個体集合
    """
    pop = []
    for i in range(n_ind - 1):
        Z = nx.random_regular_graph(k,n)
        chrom1 = list(Z.edges)
        #print(chrom1)
        chrom2 = Individual(chrom1)
        pop.append(chrom2)
    return pop

def func_ft():
    """FTアルゴリズム

    Return
    -----------
    pop:FTのベストの個体
    """
    q = depth()

    r = leaf_node(q)

    nt, t = n_t(q)

    st = s_t(nt, q)

    add_edge1(st)

    if r == 0:
    # k = q になるまで木を作成 step8を用いる
        while t < q:
            t += 1
            add_edge2(q, st, t)

        #value_i(st, q)
        #step7

        #step12へ
        i = step12(q, st)

        step13(i, q, st, r)

    else:
        while t < q - 1:
            t += 1
            add_edge2(q, st, t)
        
        i = value_i(st, q)
        #step7

        step8(i, q, st)

        step11(r)

        i = step12(q, st)
    
        step13(i, q, st, r)

def depth():
#　Qを求める
    ll = 1
    value1 = 0
    s = n - 1
    while 1:
        value2 = (k - 1) ** (ll - 1) * k
        value1 += value2
        if value1 >= s:
            ll -= 1
            break
        ll += 1
    #print("ll:{}".format(ll))
    return ll+1
    #print("value1:{}".format(value1))

def leaf_node(q):
#　Rを求める
    j = 1
    wa1 = 0
    wa2 = 0
    while 1:
        wa1 = (k - 1) ** (j - 1) * k
        wa2 += wa1
        if wa2 > n - 1:
            wa2 -= wa1
            break
        j += 1
    r = n - 1 - wa2
    return r

def n_t(q):
# ntを求める
    list_a = []
    list_a.append(1)
    t = 1
    u = 1
    while u <= q:
        n = (k - 1) ** (u - 1) * k
        list_a.append(n)
        u += 1
    # print("def-n_t--IN:{}".format(t))
    return list_a, t


def s_t(nt, q):
#　stを求める ntはstの要素の総和
    list_b = []
    n = 0
    for i in range(q + 1):
        n += nt[i]
        list_b.append(n)
    return list_b

def add_edge1(st):
#1段目の木の作成
# E ← E(1,j)
    j = 1
    # global t 
    # t += 1
    while j <= k:
        FTG.add_edge(0, j)
        # print("j:{}".format(j))
        j += 1

def add_edge2(q, st, t):
# step5
    j = 1
    atai = k * (k - 1) * (t - 1)
    
    while j <= atai:
        x = st[t-2] + math.floor((j - 1) / (k - 1))
        y = st[t-1] + j - 1
        FTG.add_edge(x, y)
        j += 1
    
def value_i(st, q):
    i = st[q - 2]
    return i


def step8(i, q, st):
# atep8の判定
    while True:
        adj_list = nx.to_dict_of_lists(FTG) # class dict
        #print("adj_list:{}".format(adj_list))

        if len(adj_list[i]) < k: #step9へ

        # step 9
            x = list((FTG.nodes)) #Gのすべての頂点
            y = adj_list[i] #iに隣接する頂点
            z = list(set(x) ^ set(y))
            #iに隣接していない頂点がzに入る
            # print("z:{}".format(z))

            a = min(adj_list.values()) # 道なしかどうかの判定
            # print("a:{}".format(a))

        #iに隣接していない頂点の次数がすべてkならstep9終了
            count = 0
            for loop in range(len(z)):
                if adj_list[z[loop]] == k:
                    count += 1
                else:
                    pass
                
            if count == len(z):
                #print("success--step9--out")
                break

            elif len(a) == 0:
                loop2 = 1
                while loop2 <= n:
                    if len(adj_list[loop2]) == 0:
                        # print("add_node:{}".format(loop2))
                        FTG.add_edge(i, loop2)
                        break
                    else:
                        loop2 += 1

            else:
                #道あり 距離最大の頂点を選ぶ
                candidate_list, k_list = k_check(adj_list, i)
                sort_node = sort(candidate_list, k_list)
                # print("sort_node:{}".format(sort_node))

                path_list = nx.shortest_path(FTG, target=i)

                deg1 = FTG.degree() #各頂点の次数

                num = len(candidate_list)
                a = candidate_list[0]
                b = len(path_list[a])

                c = a #頂点用
                d = b #距離比較

                j = 1
                while j <= num - 1:
                    a = candidate_list[j]
                    b = len(path_list[a])
                    if d < b:
                        d = b
                        c = a
                    elif d == b:
                        if c > a:
                            c = a
                    else:
                        pass
                    j += 1 

                lo = 1
                pick_list = []
                while lo < n:
                    x = len(path_list[lo])
                    if x == d:
                        pick_list.append(lo)
                    lo += 1

                num2 = len(pick_list)
                aa = pick_list[0]
                bb = deg1(aa)

                cc = aa #頂点用
                dd = bb #次数比較                

                jj = 1
                while jj <= num2 - 1:
                    aa = pick_list[jj]
                    bb = deg1(aa)
                    if dd > bb:
                        dd = bb
                        cc = aa
                    elif dd == bb:
                        if cc > aa:
                            cc = aa
                    else:
                        pass
                    jj += 1 



                FTG.add_edge(i, cc)
                    #step8に戻る

        else:
            #step10
            #print("step10---IN")
            if st[q-1] - 1 == i:
            # step11へ
                break
                
            else:
            # i ← i + 1でstep8
                i += 1
                
                #step8(i, q, st)

def k_check(adj_list, i):
    # iは追加元なので追加先には含まない 削除必要
    k_lack_list = [] # k未満の頂点リスト
    jisuu_list = []
    j = 0
    #print("adj_list:{}".format(adj_list))
    end = len(adj_list)
    #print("end:{}".format(end))
    while j < end:
        if j == i:
            j += 1
        else:
            p = len(adj_list[j])
            if p < k:
                k_lack_list.append(j)
                jisuu_list.append(p)
            j += 1
    return k_lack_list, jisuu_list

def sort(a, b):
    aa = []
    bb = np.array(b)
    sort_b = np.argsort(bb)

    for loop in range(len(a)):
        p = sort_b[loop]
        q = a[p]
        aa.append(q)
    return aa

def step11(r):
    if r == 0:
        pass
        #print("success--step11--out")

def step12(q, st):
    i = st[q-1]
    return i

def step13(i, q, st, r):
# atep13の判定
    while True:
        new_adj_list = nx.to_dict_of_lists(FTG) # class dict

        if len(new_adj_list[i]) < k: #step14へ
    # step14
            x = list((FTG.nodes)) #Gのすべての頂点
            y = new_adj_list[i] #iに隣接する頂点
        
            z = list(set(x) ^ set(y))
            #iに隣接していない頂点がzに入る
            #print("z:{}".format(z))
            
            a = min(new_adj_list.values()) # 道なしかどうかの判定
            #print("a:{}".format(a))

        #iに隣接していない頂点の次数がすべてkならstep14終了
            count = 0
            for loop in range(len(z)):
                if new_adj_list[z[loop]] == k:
                    count += 1
                else:
                    pass

            if count == len(z):
                #print("success--step14--out")
                break

            elif len(a) == 0:
                #道なしnew_adj_listの中身なし = 距離無限大の頂点あり
                loop2 = 1
                while loop2 <= n:
                    if len(new_adj_list[loop2]) == 0:
                        # print("add_node:{}".format(loop2))
                        FTG.add_edge(i, loop2)
                        break
                    else:
                        loop2 += 1

            else:
                #道あり 距離最大の頂点を選ぶ
                candidate_list, k_list = k_check(new_adj_list, i)
                #print("candidate:{}".format(candidate_list))
                
                sort_node = sort(candidate_list, k_list)
                #print("sort_node:{}".format(sort_node))

                #print("i:{}".format(i))
                path_list = nx.shortest_path(FTG, target=i)
                #print("path_list:{}".format(path_list))

                deg2 = FTG.degree() #各頂点の次数

                num = len(candidate_list)
                a = candidate_list[0]
                b = len(path_list[a])

                c = a #頂点用
                d = b #距離比較

                j = 1
                while j <= num - 1:
                    a = candidate_list[j]
                    b = len(path_list[a])
                    if d < b:
                        d = b
                        c = a
                    elif d == b:
                        if c > a:
                            c = a
                    else:
                        pass
                    j += 1 

                lo = 1
                pick_list = []
                while lo < n:
                    x = len(path_list[lo])
                    if x == d:
                        pick_list.append(lo)
                    lo += 1

                num2 = len(pick_list)
                aa = pick_list[0]
                bb = deg2(aa)

                cc = aa #頂点用
                dd = bb #次数比較                

                jj = 1
                while jj <= num2 - 1:
                    aa = pick_list[jj]
                    bb = deg2(aa)
                    if dd > bb:
                        dd = bb
                        cc = aa
                    elif dd == bb:
                        if cc > aa:
                            cc = aa
                    else:
                        pass
                    jj += 1 
                # print("last_c:{}".format(c))
                # print("last_d:{}".format(i))
                

                FTG.add_edge(i, cc)
                    #step13に戻る

        else:
            #step15
            if r == 0:
                value = st[q] + r - 1
            else:
                value = st[q - 1] + r - 1
            # print("value:{}".format(value))
            if value == i:
                #print("success--step15--out")
                break
                
            else:
            # i ← i + 1でstep13
                i += 1
                #step13(i, q, st, r)
                

class Individual(np.ndarray):
    fitness = None
    def __new__(cls, a):
        return np.asarray(a).view(cls)

def set_fitness(value_func, pop):
    """適応度(平均頂点間距離)の設定
    Parameter
    ----------
    value_func:平均頂点間距離
    pop:個体集合
    """
    
    # 並列化実装
    fit = joblib.Parallel(n_jobs = -1, verbose = 0)([joblib.delayed(value_func)(i) for i in pop])

    for i, fit in zip(pop, fit):
        i.fitness = fit

def value_func(ind):
    """適応度(平均頂点間距離)の計算

    Parameter
    ----------
    ind:個体

    Return
    -----------
    distance:平均頂点間距離
    """
    g1 = nx.Graph()
    g1.add_edges_from(ind)

    try:
        distance = nx.average_shortest_path_length(g1)
    
    except nx.NetworkXError:
        distance = n
        
    return distance

def elite_selection(pop):
    """エリート選択

    Parameter
    ----------
    pop:個体集合

    Return
    -----------
    pop:最も平均頂点間距離が小さい個体
    """

    elite = []
    elite.append(min(pop, key=attrgetter("fitness")))

    return elite

def selTournament(pop, n_ind, tournsize):
    """選択

    Parameter
    ----------
    pop:個体集合
    n_ind:個体数
    tournsize:トーナメントサイズ

    Return
    -----------
    chosen:選択により得られる個体集合
    """

    chosen = []
    for i in range(n_ind):
        aspirants = [random.choice(pop) for j in range(tournsize)]
        #print("aspirants:{}".format(aspirants))

        chosen.append(min(aspirants, key=attrgetter("fitness")))

    return chosen

def irekae(ab, e):
    """個体の辺リストを昇順にソート

    Parameter
    ----------
    ab:個体(辺リスト)
    e:k正則グラフの辺の総数

    Return
    -----------
    re_ab:昇順にソートされた個体
    """
    re_ab = []
    for i in range(e):
        swap = list(ab[i])
        if swap[0] > swap[1]:
            d = swap[0]
            swap[0] = swap[1]
            swap[1] = d
            #re_ab[i] = swap
            re_ab.append(swap)

        else:
            #re_ab[i] = swap
            re_ab.append(swap)
    #print(ab)
    re_ab.sort()
    return re_ab

def cutplace(n, a, b, e):
    """交叉点を求める

    Parameter
    ----------
    n:頂点数
    a:個体
    b:個体
    e:k正則グラフの辺の総数

    Return
    -----------
    cross_a:個体aのインデックス
    cross_b:個体bのインデックス
    """    

    x = len(a)
    point = random.randint(0,x-1)
    #print("point:{}".format(point))

    cross_a = point

    select_edge = a[point]
    #print("select_edge:{}".format(select_edge))
    #print(type(select_edge))

    b_ind = my_index(b, select_edge, -1)

    if b_ind == -1:
        b.append(select_edge)
        #print(a)
        b_sort = irekae(b, e+1)
        #print("b_sort:{}".format(b_sort))
        b_ind = my_index(b_sort, select_edge, -1)
        b_sort.remove(select_edge)
        cross_b = b_ind
        
    else:
        cross_b = b_ind


    return cross_a, cross_b

def my_index(l, x, default=False):
    """リストの要素の検索

    Parameter
    ----------
    l:リスト
    x:検索したい要素

    Return
    -----------
    リスト内に要素があるならインデックスを返す
    リスト内に要素がないなら-1を返す
    """    

    return l.index(x) if x in l else default

def cross(A, B, c1, c2):
    """交叉

    Parameter
    ----------
    A:個体
    B:個体
    c1:aの交叉点
    c2:bの交叉点

    Return
    -----------
    tmp1:交叉後の個体a
    tmp2:交叉後の個体b
    """    
    x = len(A)
    y = len(B)
    tmp1 = A.copy()
    tmp2 = B.copy()
    C = []
    D = []

    C = tmp1[c1:]
    D = tmp2[c2:]
    del tmp1[c1:]
    del tmp2[c2:]
    tmp1 = tmp1 + D
    tmp2 = tmp2 + C

    return tmp1, tmp2

def degree_check(a, n):
    """各頂点の次数の計算

    Parameter
    ----------
    a:個体
    n:頂点数

    Return
    -----------
    nd:n個の頂点の次数列
    """    
    nd = []
    i = 0

    g3 = nx.Graph()
    g3.add_edges_from(a)

    node_g3 = nx.to_dict_of_lists(g3) #g3のグラフの隣接リスト
    #print("node_g3:{}".format(node_g3))
 
    while i < n:
        try: 
            y = len(node_g3[i]) #yには頂点iの次数
            nd.append(y)
        
        except KeyError: #KeyError個体に頂点iが含まれていないため次数0を追加
            nd.append(0)
        
        i += 1 
    #print("nd:{}".format(list(g3.degree())))
    return nd


def edge_delete(a, k, kotai_a, n):
    """k以下になるまで辺削除を繰り返す、次数が高い辺を優先的に削除、

    Parameter
    ----------
    a:次数リスト
    k:正則グラフの次数
    kotai_a:個体
    n:頂点数

    Return
    -----------
    kotai_a:次数がk以下の個体
    """    
    #sは最大次数の頂点
    aikata_list = [] #sに隣接する頂点のリスト
    replace_list = [] #aikata_list内にある各頂点の次数列
    #ix_sortはreplace_listを降順にソート   次数が高い頂点を優先的に削除するため
    #ix_sortの先頭の次数を持つ頂点を探す.これをzとする
    #辺(s, z)を削除する。ただし、s > z なら入れ替える

    jisuu_list_sort = sorted(a, reverse=True)
    #print("jisuu_list_sort:{}".format(jisuu_list_sort))

    g3 = nx.Graph()
    g3.add_edges_from(kotai_a)
    adj_list = nx.to_dict_of_lists(g3)

    while jisuu_list_sort[0] > k: #全ての次数がk以下ならスルー list先頭check
        l = np.array(a)
        l2 = np.argsort(-l)
        delete_sort = list(l2)

        s = delete_sort[0]

        aikata_list = adj_list[s]
        #print("aikata_list:{}".format(aikata_list))

        for t in range(len(aikata_list)):
            b = g3.degree(aikata_list[t]) 
            replace_list.append(b) # aikataの頂点の次数
        #print("replace_list:{}".format(replace_list))

        # sに隣接している頂点の最大を削除
        l3 = np.array(replace_list)
        ix_sort = np.argsort(-l3)
        #print("ix_sort:{}".format(ix_sort))
        z = aikata_list[ix_sort[0]]
        #print("z:{}".format(z))

        xx, yy = trade(s, z)
        # kotai_aの(xx, yy)削除
        #print("({}, {})".format(xx, yy))
        kotai_a.remove([xx, yy])
        #print("delete_kotai_a:{}".format(kotai_a))


        #置換1か所終了各リストの初期化
        aikata_list.clear()
        jisuu_list_sort.clear()
        replace_list.clear()
        node = len((g3.nodes))
        mylist = list(range(node))
        g3.remove_nodes_from(mylist)
        #print(g3.nodes())

        # ↑次数下げたのでjisuu_listに変化あり

        a = degree_check(kotai_a, n)
        #print("after_a:{}".format(a))
        jisuu_list_sort = sorted(a, reverse=True)
        #print("after_jisuu_list_sort:{}".format(jisuu_list_sort))
        g3.add_edges_from(kotai_a)
        adj_list = nx.to_dict_of_lists(g3)
        #print("after_adj_list:{}".format(adj_list))

    return kotai_a

def trade(a, b):
    """頂点番号を a < b にする

    Parameter
    ----------
    a:頂点番号
    b:頂点番号

    Return
    -----------
    a:頂点番号
    b:頂点番号
    a < bである
    """        
    if a < b:
        pass
    else:
        c = b
        b = a
        a = c
    
    return a, b

def havel(a, n):
    """Havel-Hakimiを用いて、正則性を判断した後、辺を追加し、非正則グラフから
    正則グラフに変換する。ただし、この段階では、多重辺を許容する

    Parameter
    ----------
    a:個体
    n:頂点数

    Return
    -----------
    a:多重辺の可能性ありの個体
    double_edge:多重辺があるとき多重辺を把握
    """    
    
    """
    falseとは、Havel-Hakamiによって、正則性が保証されないときであり
    このとき、引数a(個体)から辺を削除して、再びHavel-Hakamiを適用する
    """
    g5 = nx.Graph()
    g5.add_edges_from(a)
    plot_list = []
    plot_2_list = []
    plot_2_node = []
    false_list = []
    double_edge = [] # 多重辺
    a_reserve = []
    delete_candi = []
    flag = 0

    a_reserve = copy.deepcopy(a) #false用

    havel_list, delete_edge = countjisuu(a, k, n)

    havel_list_down = sorted(havel_list, reverse=True)  #ソート
    #print("havel_list_down1:{}".format(havel_list_down))
    c = havel_list_down.count(0)
    #print("c={}".format(c))

    #print("degree_seq:{}".format(list(g5.degree())))

    while c != n:
        top = havel_list_down[0]
        #print("top:{}".format(top))
        havel_list_down[0] = 0

        for s in range(1,top+1,1):
            havel_list_down[s] = havel_list_down[s] - 1
        #print("havel_list_down_after2:{}".format(havel_list_down))

        if flag == 1:
            l = np.array(plot_list)
            plot_2_list = np.argsort(-l)

            for loop in range(n):
                c = plot_2_list[loop]
                #print("c={}".format(c))
                b = plot_node[c]
                #print("b={}".format(b))
                plot_2_node.append(b)
            plot_node.clear()
            plot_node = plot_2_node.copy()         

            for plus in range(top): #topの値の数だけGに辺の数を追加
                x = plot_2_node[0]
                y = plot_2_node[plus + 1]
                #print("frag1----x={}:y={}".format(x,y))
                x, y = trade(x, y)
                #print("frag1----x={}:y={}".format(x,y))
                exist1 = my_index(a, [x, y], -1)
                if exist1 != -1:
                    double_edge.append((x, y)) 
                #g5.add_edge(x, y)
                a.append([x, y])
                #print("frag1----x={}:y={}".format(x,y))
                false_list.append((x, y))
            plot_2_node.clear()   

            plot_2_list = np.delete(plot_2_list, [0])    

        if flag == 0:  # frag == 0  # 1回目だけはhavel_listを使うため
            #print("before_plot_2_list:{}".format(plot_2_list))
            l1 = np.array(havel_list)
            l2 = np.argsort(-l1)
            plot_node = list(l2)

            flag = 1
            for plus in range(top): #topの値の数だけグラフに辺を追加
                x = plot_node[0]
                y = plot_node[plus + 1]
                #print("frag0----x={}:y={}".format(x,y))
                x, y = trade(x, y)
                exist0 = my_index(a, [x, y], -1)
                if exist0 != -1:
                    double_edge.append((x, y)) 
                #g5.add_edge(x, y)
                a.append([x, y])
                false_list.append((x, y))

        plot_list.clear()
        plot_list = havel_list_down #havel後のリストをソート前にコピー
        havel_list_down = sorted(havel_list_down, reverse=True)  #ソート
        #print("havel_list_down3:{}".format(havel_list_down))

    # falseの判定
        if havel_list_down[n-1] < 0: #falseの場合、すでに次数3の頂点間の辺を削除    
            #この段階でflag0と1で追加した辺の削除
            a = copy.deepcopy(a_reserve) #false用 初期化          
            #g5.remove_edges_from(false_list)

    # falseのため追加した辺の削除
            z = len(delete_edge)
            #print("z:{}".format(z))
            delete_edge = list(delete_edge)
            #print("delete_edge:{}".format(delete_edge))
            #print("a_reserve:{}".format(a_reserve))

            while True:    
                xx, yy = random.sample(delete_edge, 2)
                delete_candi.append([xx, yy])
                re_index = my_index(a_reserve, delete_candi[0], -1)
                if re_index != -1:
                    a_reserve.pop(re_index)
                    a.pop(re_index)
                    break
                delete_candi.clear()

            delete_edge.clear()
            havel_list_down.clear()
            havel_list.clear()
            double_edge.clear()
            havel_list, delete_edge = countjisuu(a_reserve, k, n)
            havel_list_down = sorted(havel_list, reverse=True)  #ソート
        
        c = havel_list_down.count(0)
        #print("c_after:{}".format(c))

    else:

        return a, double_edge


def countjisuu(a, k, n):
    """次数kの不足分を計算する

    Parameter
    ----------
    a:個体
    k:正則グラフの次数
    n:頂点数

    Return
    -----------
    jisuulack:次数kの不足分のリスト
    delete_edge:既に次数kである頂点のリスト
    """    
    g4 = nx.Graph()
    g4.add_edges_from(a)
    jisuulack = [] #kに対しての不足分
    delete_edge = []

    node_g4 = nx.to_dict_of_lists(g4) #g4のグラフの隣接リスト
    #print("node_g4:{}".format(node_g4))

    i = 0
    while i < n:
        try:
            y = len(node_g4[i]) #yには頂点iの次数
            p = k - y
            jisuulack.append(p)
            if p == 0:
                delete_edge.append(i)
        except KeyError:
            jisuulack.append(k)
        i += 1 
    #print("jisuulack:{}".format(list(g4.degree())))
    return jisuulack, delete_edge


def switch(a, kotai, n):
    """2-switchを用いて、多重辺の削除

    Parameter
    ----------
    a:多重辺の辺
    kotai:個体
    n:頂点数

    Return
    -----------
    kotai:多重辺がないk正則グラフの個体
    """    

    count = len(a) #多重辺の個数

    for i in range(count):
        g6 = nx.Graph()
        g6.add_edges_from(kotai)

        b = a[i]

        x = b[0]
        y = b[1]

        x_delete = x
        y_delete = y

        candi1 = list(g6.neighbors(x))
        candi2 = list(g6.neighbors(y))

        mylist1 = list(range(0, n, 1))
        mylist2 = list(range(0, n, 1))

        loop1 = len(candi1)
        loop2 = len(candi2)

        for s in range(loop1):
            mylist1.remove(candi1[s])
        mylist1.remove(x)

        for s in range(loop2):
            mylist2.remove(candi2[s])
        mylist2.remove(y)

        while True:
            z1 = random.sample(mylist1, 1)
            z2 = random.sample(mylist2, 1)

            j = z1[0]
            k = z2[0]

            jj, kk = trade(j, k)

            exist0 = my_index(kotai, [jj, kk], -1)
            if exist0 != -1:
                #print("j:{}, k:{}".format(j,k))
                x, j = trade(x, j)
                y, k = trade(y, k)
                kotai.append([x,j])
                kotai.append([y,k])

                kotai.remove([x_delete, y_delete])
                kotai.remove([jj, kk])
                #print("kotai:{}".format(kotai))

                break
    
    return kotai


def mutation(kotai):
    """2-switchを用いて、突然変異

    Parameter
    ----------
    kotai:個体

    Return
    -----------
    kotai:突然変異後の個体
    """    
    while True:
        ns = rand_ints_nodup(0, E-1, 2)
        num1 = ns[0]
        num2 = ns[1]

        a = kotai[num1]
        b = kotai[num2]

        i = a[0]
        j = a[1]

        k = b[0]
        l = b[1]

        i, k = trade(i,k)
        j, l = trade(j,l)

        value1 = my_index(kotai, [i, k] ,-1)
        value2 = my_index(kotai, [j, l] ,-1)
        if value1 == -1 and value2 == -1 and i != k and j != l:
            #　kotaiに対して、辺の追加と削除してからソートリターン
            #print("before:{}".format(kotai))
            kotai.append([i,k])
            kotai.append([j,l])
            kotai.remove([a[0],a[1]])
            kotai.remove([b[0],b[1]])
            #print("after:{}".format(kotai))

            return kotai

            break

def rand_ints_nodup(a, b, k):
    ns = []
    while len(ns) < k:
        n = random.randint(a, b)
        #print("n:{}".format(n))
        if not n in ns:
            ns.append(n)
    return ns

if __name__ == "__main__":

    main()
